﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace CSHowDoISamples
{
    /// <summary>
    /// Interaction logic for UsingTileCache.xaml
    /// </summary>
    public partial class UsingTileCache : UserControl
    {
        public UsingTileCache()
        {
            InitializeComponent();
        }

        private void WpfMap_Loaded(object sender, RoutedEventArgs e)
        {
            //wpfMap1.MapUnit = GeographyUnit.DecimalDegree;
            //wpfMap1.CurrentExtent = new RectangleShape(-155.733, 95.60, 104.42, -81.9);
            wpfMap1.MapUnit = GeographyUnit.Meter;
            wpfMap1.CurrentExtent = new RectangleShape(-13939426.6371, 6701997.4056, -7812401.86, 2626987.386962);
            wpfMap1.ZoomLevelSet = new MyZoomlevelSet();

            LayerOverlay worldOverlay = new LayerOverlay();
            worldOverlay.TileCache = new FileBitmapTileCache(@"D:\Cache\", "WPFCache_meter_customZoom");
            
            wpfMap1.Overlays.Add("WorldOverlay", worldOverlay);

            BackgroundLayer backgroundLayer = new BackgroundLayer(new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean));
            worldOverlay.Layers.Add(backgroundLayer);

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"..\..\SampleData\Data\Countries02.shp");
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            Proj4Projection proj4 = new Proj4Projection();
            proj4.InternalProjectionParametersString = Proj4Projection.GetDecimalDegreesParametersString();
            proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
            proj4.Open();
            worldLayer.FeatureSource.Projection = proj4;

            worldOverlay.Layers.Add("WorldLayer", worldLayer);

            wpfMap1.Refresh();
        }

        class MyZoomlevelSet : ZoomLevelSet
        {
            public MyZoomlevelSet()
            {
                ZoomLevel20.Scale = 564.25;
                ZoomLevel19.Scale = 1128.5;
                ZoomLevel18.Scale = 2257;
                ZoomLevel17.Scale = 4514;
                ZoomLevel16.Scale = 9028;
                ZoomLevel15.Scale = 18055.99;
                ZoomLevel14.Scale = 36111.98;
                ZoomLevel13.Scale = 72223.96;
                ZoomLevel12.Scale = 144447.93;
                ZoomLevel11.Scale = 288895.85;
                ZoomLevel10.Scale = 577791.71;
                ZoomLevel09.Scale = 1155583.42;
                ZoomLevel08.Scale = 2311166.84;
                ZoomLevel07.Scale = 4622333.68;
                //ZoomLevel06.Scale = 9244677.36;
                //ZoomLevel05.Scale = 18489334.72;
                //ZoomLevel04.Scale = 36978669.43;
                //ZoomLevel03.Scale = 73957338.86;
                ZoomLevel06.Scale = 9886730.47925373;
                ZoomLevel05.Scale = 19773460.9585075;
                ZoomLevel04.Scale = 39546921.9170149;
                ZoomLevel03.Scale = 79093843.8340299;

                ZoomLevel02.Scale = 147914677.73;
                ZoomLevel01.Scale = 295829355.45;
            }
        }
    }
}
